<template>
    <div class="login-box">
        <div class="login-logo center">
            <img src="https://registerdev.cellvoz.com/images/logo-vertical.svg" style="margin: 0 auto;">
        </div>
        <!-- /.login-logo -->
        <div class="card">
            <div class="card-body login-card-body">
                <p class="login-box-msg">Restaura tu contraseña</p>
                <form method="post">
                    <div class="input-group mb-3">
                        <input @keyup.enter="restorePassword" v-model="fillLogin.cPassword" type="password" class="form-control" placeholder="Contraseña">
                        <div class="input-group-append">
                            <div class="input-group-text">
                                <span class="fas fa-lock"></span>
                            </div>
                        </div>
                    </div>
                    <div class="input-group mb-3">
                        <input @keyup.enter="restorePassword" v-model="fillLogin.cConfirmPassword" type="password" class="form-control" placeholder="Confirmar contraseña">
                        <div class="input-group-append">
                            <div class="input-group-text">
                                <span class="fas fa-lock"></span>
                            </div>
                        </div>
                    </div>
                </form>

                <div class="row">
                    <div class="col-12">
                        <span v-if="error">
                            <div v-for="(e, index) in mensajeError" :key="index" v-text="e" class="callout callout-danger"></div>
                        </span>
                    </div>
                </div>
                <div class="social-auth-links text-center mb-3">
                    <button class="btn btn-flat btn-primary" @click.prevent="restorePassword" v-loading.fullscreen.lock="fullscreenLoading">
                        Guardar
                    </button>              
                </div>
                
            </div>
            <!-- /.login-card-body -->
        </div>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                fillLogin: {
                    cConfirmPassword: '',
                    cPassword: ''
                },
                fullscreenLoading: false,
                error: 0,
                mensajeError: []
            }
        },
        methods: {
            restorePassword() {
                if(this.validForm()) {
                    return;
                }

                this.fullscreenLoading = true;
                axios.post('/restorePassword', {
                    'cPassword' : this.fillLogin.cPassword,                    
                }).then(response=> {
                    // console.log(response);
                    if(response.data.code == 401) {
                        this.restoreFailed(response.data.message);
                    }
                    if(response.data.code == 200) {
                        this.restoreSuccess();
                    }              
                });
            },
            validForm() {
                this.error = 0;
                this.mensajeError = [];

                if(!this.fillLogin.cPassword) {
                    this.mensajeError.push('La contraseña es un campo obligatorio');
                }

                if(!this.fillLogin.cConfirmPassword) {
                    this.mensajeError.push('La confirmación de la contraseña es un campo obligatorio');
                }

                if(this.fillLogin.cPassword !== this.fillLogin.cConfirmPassword) {
                    this.mensajeError.push('Las contraseñas no coinciden');
                }

                if(this.fillLogin.cPassword.length < 8){
                    this.mensajeError.push('La contraseña debe contener almenos 8 caracteres');
                }else if(! /[A-Z]/.test(this.fillLogin.cPassword)){
                    this.mensajeError.push('La contraseña debe contener almenos una mayuscula');
                }else if(! /\d/.test(this.fillLogin.cPassword)){
                    this.mensajeError.push('La contraseña debe contener almenos un número');
                }

                if(this.mensajeError.length) {
                    this.error = 1;
                }

                return this.error;
            },
            restoreFailed(message) {
                this.fullscreenLoading = false;
                this.error = 0;
                this.mensajeError = []; 

                this.mensajeError.push((message) ? message : 'Hubo un error en la actualización de la contraseña, contacte con el administrador.');

                this.fillLogin.cConfirmPassword = '';
                this.fillLogin.cPassword = '';

                if(this.mensajeError.length) {
                    this.error = 1;
                }

                return this.error;
            }, 
            restoreSuccess() {
                window.location.href = '/dashboard';
                setTimeout(()=>{
                    this.fullscreenLoading = false;
                },1800)
            }, 
        }
    }
</script>

<style>

</style>